################################################################################
#
# date:     2007/03/09
# modified: 2009/05/03
#
# allowes computation of apportionment whith bazidata 
#
################################################################################

computeApportionment <- function(bazidata, ...) {

	if (any(names(bazidata) == "housesize")) {	# vector apportionment
		monopropApp(housesize = bazidata$housesize,
				votes = bazidata$votes,
				appMethod = bazidata$appMethod,
				pq = bazidata$pq,
				minConstr = bazidata$minConstr,
				maxConstr = bazidata$maxConstr,
				directSeats = bazidata$directSeats, 
				listCombination = bazidata$listCombination, 
				base = bazidata$base, 
				min = bazidata$min, 
				max = bazidata$max,  
				isBmmPwr = bazidata$isBmmPwr, 
				...) 
	}
	else if (bazidata$separate) {	# districtwise apportionment
		districtwiseApp(districtMagnitudes = bazidata$districtMagnitudes,
				votes = bazidata$votes,
				appMethod = bazidata$appMethod,
				pq = bazidata$pq,
				minConstr = bazidata$minConstr,
				maxConstr=bazidata$maxConstr,
				directSeats = bazidata$directSeats,
				listCombination = bazidata$listCombination, ...)
	}
	else {	# matrix apportionment
		bipropApp(districtMagnitudes = bazidata$districtMagnitudes,
				votes = bazidata$votes,
				appMethod = bazidata$appMethod,
				pq = bazidata$pq,
				nzz = bazidata$nzz,
				minConstr = bazidata$minConstr,
				minConstrSuper = bazidata$minConstrSuper, ...)
	}	
}