################################################################################
#
# date:     2007/02/26
# modified: 2007/10/11
#
# corresponds to class rjBazi.MonopropApp for districtwise apporitonment
#
################################################################################



# districtw apportionment
districtwiseApp <- 
function(districtMagnitudes, votes, appMethod = "DivStd", pq = NULL, minConstr = NA, maxConstr = NA, directSeats = NA, listCombination = NA, sorting = "app", printDistr=FALSE, name = NULL)
{
	warning("Still not yet completely functioning.\n")
	# check sorting --> put it into checkParam later?
	allowedSortingMethods = c("none", "alpha", "app", "votes")
	if (length(sorting) != 1) stop("Please check sorting method.")
	if (!is.element(sorting, allowedSortingMethods)) stop("Sorting method not allowed.")

	# some initial checks
	checkParams(list(districtMagnitudes = districtMagnitudes, votes = votes, appMethod = appMethod,
			pq = pq, minConstr = minConstr, maxConstr = maxConstr, directSeats = directSeats), TRUE)	
	
	# some inits
	rows <- dim(votes)[1]
	cols <- dim(votes)[2]
	
	# row/col names
	if (is.null(rownames(votes))) rownames(votes) <- mapply(paste, rep("D", rows) ,seq(1, rows), sep="")
	if (is.null(colnames(votes))) colnames(votes) <- mapply(paste, rep("P", cols) ,seq(1, cols), sep="")	
	
	# transform data
	districtMagnitudes <- as.integer(districtMagnitudes)
	districtNames <- rownames(votes)
	partyNames <- colnames(votes)

	if (!(identical(listCombination, NA) || identical(listCombination, NULL))) {
		printDistr <- TRUE
	}


	# init return object
	app <- list()
	app$name <- name
	if (printDistr) {
	  districtApportionments <- list()
	  length(districtApportionments) <- rows
	} 
	appMat <- matrix(nrow = rows, ncol = cols)
	tieMat <- matrix(nrow = rows, ncol = cols)
	
	for (i in 1:rows) {

		if (identical(listCombination, NA) || identical(listCombination, NULL)) {
			# init rjBazi
			distrApp <- .jnew("rjBazi/MonopropApp", votes[i,], partyNames)
			if (!(identical(minConstr, NA) || identical(minConstr, NULL))) .jcall(distrApp, returnSig = "V", "setMinConstr", as.integer(minConstr[i,]))
			if (!(identical(maxConstr, NA) || identical(maxConstr, NULL))) .jcall(distrApp, returnSig = "V", "setMaxConstr", as.integer(maxConstr[i,]))
			if (identical(directSeats, NA) || identical(directSeats, NULL)) dS <- NA
			else dS <- directSeats[i,]

			# compute apportionment
			if (appMethod == "DivStat") stop("DivStat is not allowed yet.")
			
			tmpApp <- vectorApp(rjBaziObjRef = distrApp, h = districtMagnitudes[i],
				rM = appMethod, pq = NULL, dS = dS, rT = FALSE, pN = partyNames)
#			.jcall(distrApp, returnSig="I", "calcApp", as.integer(districtMagnitudes[i]), appMethod)
			tmpApp$name <- paste(name, " (", districtNames[i], ")", sep="")
			class(tmpApp) <- "RBaziApportionment"
			# TBD: getting more info
			class(app) <- "RBaziApportionment"
			if (printDistr) districtApportionments[[i]] <- tmpApp
			appMat[i,] <- tmpApp$apportionment
			tieMat[i,] <- tmpApp$ties
		}
		else {	
			if (identical(minConstr, NA) || identical(minConstr, NULL)) mR <- NA
			else mR <- minConstr[i,]
			if (identical(maxConstr, NA) || identical(maxConstr, NULL)) MR <- NA
			else MR <- maxConstr[i,]
			if (identical(directSeats, NA) || identical(directSeats, NULL)) dS <- NA
			else dS <- directSeats[i,]
			tmpApp <- listCombApp(housesize = districtMagnitudes[i], votes = votes[i,],
				appMethod = appMethod, pq = pq, minConstr = mR, maxConstr = MR,
				directSeats = dS, listCombination = listCombination[i,])
			tmpOrder <- order(names(tmpApp$Summary$apportionment))
			appMat[i,] <- tmpApp$Summary$apportionment[tmpOrder]
			if (all(listCombination[i,]==0)) 
				districtApportionments[[i]] <- list(apportionment = tmpApp$Superapportionment)
			else	
				districtApportionments[[i]] <- list(Superapportionment = tmpApp$Superapportionment, Subapportionment=tmpApp$Subapportionment)
		}
	}
	# building return object
	if (printDistr) app$districtApportionments <- districtApportionments
	partiesWhichGetSeats <- which(colSums(appMat) > 0)
	app$votes <- votes[,partiesWhichGetSeats]
	appMat <- appMat[,partiesWhichGetSeats]
	appMat <- rbind(appMat, colSums(appMat))
	partyNames <- partyNames[partiesWhichGetSeats]
	rownames(appMat) <- c(districtNames, "Total Seats")
	colnames(appMat) <- partyNames
	app$apportionment <- appMat

	if (sorting == "alpha") tmpOrder <- order(partyNames)
	else if (sorting == "app") tmpOrder <- order(appMat[(rows+1),], decreasing = T)
	else if (sorting == "votes") tmpOrder <- order(colSums(app$votes), decreasing = T)
	
	if (sorting != "none") {
	  for (k in ifelse(printDistr, 2, 1):length(app)) app[[k]] <- app[[k]][,tmpOrder]}
	
	# return
	class(app) <- "RBaziApportionment"
	return(app)
}	
			
