################################################################################
#
# date:     2007/09/30
# modified: 2007/10/31
#
# corresponds to class rjBazi.MonopropApp for districtwise apporitonment
#
################################################################################



# districtw apportionment
listCombApp <- # add directSeats?
function(housesize, votes, appMethod, pq = NULL, minConstr = NA, maxConstr = NA, directSeats = NA, listCombination)
{
	
	# checks ? necessary for internal function
	
	# init
	partyNames <- names(votes)
	
	# decompose 0 -> no list combination >0 list combination
	# new vector of votes
	noOfLists <- max(listCombination)
	aggVotes <- rep(0, noOfLists)
	aggPartyNames <- rep("", noOfLists)
	aggregateMinConstr <- !identical(minConstr, NA)
	aggregateMaxConstr <- !identical(maxConstr, NA)
	aggregateDS <- !identical(directSeats, NA)
	
	if (aggregateMinConstr) aggMinConstr <- rep(0, noOfLists)
	else aggMinConstr <- NA
	if (aggregateMaxConstr) aggMaxConstr <- rep(0, noOfLists)
	else aggMaxConstr <- NA
	if (aggregateDS) aggDS <- rep(0, noOfLists)
	else aggDS <- NA
	
	for (l in 1:noOfLists) {
		aggPartyNames[l] <- paste(partyNames[listCombination == l], sep = "", collapse = " + ")
		aggVotes[l] <- sum(votes[listCombination == l])
		if (aggregateMinConstr) aggMinConstr[l] <- sum(minConstr[listCombination == l])
		if (aggregateMaxConstr) aggMaxConstr[l] <- sum(maxConstr[listCombination == l])
		if (aggregateDS) aggDS[l] <- sum(directSeats[listCombination == l])
	}
	
	names(aggVotes) <- aggPartyNames
	if (aggregateMinConstr) names(aggMinConstr) <- aggPartyNames
	if (aggregateMaxConstr) names(aggMaxConstr) <- aggPartyNames
	aggVotes <- c(aggVotes, votes[listCombination == 0])
	if (aggregateMinConstr) aggMinConstr <- c(aggMinConstr, minConstr[listCombination == 0])
	if (aggregateMaxConstr) aggMaxConstr <- c(aggMaxConstr, maxConstr[listCombination == 0])
	if (aggregateDS) aggDS<- c(aggDS, directSeats[listCombination == 0])
	notInListComb <- is.element(names(aggVotes), names(votes))
		
	# set java-object
	appRef <- .jnew("rjBazi/MonopropApp", aggVotes, names(aggVotes))
	if (aggregateMinConstr) .jcall(appRef, returnSig = "V", "setMinConstr", as.integer(aggMinConstr))
	if (aggregateMaxConstr) .jcall(appRef, returnSig = "V", "setMaxConstr", as.integer(aggMaxConstr))
		
	# init return object
	appInfo <- list()
	
	# superapportionment
	appInfo$Superapportionment <- vectorApp(rjBaziObjRef = appRef, h = housesize,
									rM = appMethod, pq = pq, dS = aggDS,
									rT = FALSE, pN = names(aggVotes))
	
	# subapportionment and Summary
	appInfo$Summary <- list()
	appInfo$Summary$votes <- c()
	appInfo$Summary$apportionment <- c()
	if (aggregateMinConstr) appInfo$Summary$minConstr <- c()
	if (aggregateMaxConstr) appInfo$Summary$maxConstr <- c()
	if (aggregateDS) appInfo$Summary$overhang <- c()
	appInfo$Subapportionment <- list()
	partyNames <- names(votes)
	if (noOfLists > 0) {
	for (l in 1:noOfLists) {
		appRef <- .jnew("rjBazi/MonopropApp", votes[listCombination == l], partyNames[listCombination == l])
		if (aggregateMinConstr) {
			.jcall(appRef, returnSig = "V", "setMinConstr", as.integer(minConstr[listCombination == l]))
			appInfo$Summary$minConstr <- minConstr[listCombination == l]
		}	
		if (aggregateMaxConstr) {
			.jcall(appRef, returnSig = "V", "setMaxConstr", as.integer(maxConstr[listCombination == l]))
			appInfo$Summary$maxConstr <- maxConstr[listCombination == l]
		}	
		h <- appInfo$Superapportionment$apportionment[l]
		names(h) <- NULL
		ifelse(aggregateDS, dS <- directSeats[listCombination == l], dS <- NA)
		tmpApp <- vectorApp(rjBaziObjRef = appRef, h = h, rM = appMethod,
					pq = pq, dS = dS, rT = FALSE, pN = partyNames[listCombination == l])
		tmpApp$votes <- votes[listCombination == l]
		tmpApp <- tmpApp[c(1, length(tmpApp), seq(2, length(tmpApp)-1))]
		appInfo$Subapportionment[[l]] <- tmpApp
		appInfo$Summary$votes <- c(appInfo$Summary$votes, appInfo$Subapportionment[[l]]$votes)
		appInfo$Summary$apportionment <- c(appInfo$Summary$apportionment, appInfo$Subapportionment[[l]]$apportionment)
		if (aggregateDS) appInfo$Summary$overhang <- c(appInfo$Summary$overhang, appInfo$Subapportionment[[l]]$overhang)
	}}
	
	appInfo <- appInfo[c(1,3,2)]
	appInfo$Summary$votes <- c(appInfo$Summary$votes, aggVotes[notInListComb])
	appInfo$Summary$apportionment <- c(appInfo$Summary$apportionment, appInfo$Superapportionment$apportionment[notInListComb])
	if (aggregateMinConstr) 
		appInfo$Summary$minConstr <- c(appInfo$Summary$minConstr, aggMinConstr[notInListComb])
	if (aggregateMaxConstr) 
		appInfo$Summary$maxConstr <- c(appInfo$Summary$maxConstr, aggMaxConstr[notInListComb])
	if (aggregateDS) 
		appInfo$Summary$overhang <- c(appInfo$Summary$overhang, appInfo$Superapportionment$overhang[notInListComb])
	
	# return
	return(appInfo)
}	
			
