\name{computeApportionment}

\alias{computeApportionment}

\title{Adapter module for all BAZI-apportionment options}

\description{Computes apportionment from bazidata}

\usage{
computeApportionment(bazidata, ...)
}


\arguments{
	\item{bazidata}{Bazidata as created by \code{read.bazi} including, district
		magnitudes, votes, minimum requirements, rounding method, and indicator 
		for nzz}
	\item{...}{additional options for vector, districtwise, or bipropotional 
		apportionment as algos, ...}
}

\details{
Passes data read by \code{read.bazi} on to \code{bipropApp, districtwiseApp} or
\code{monopropApp}.
}

\value{
List containing apportionment.
}

\seealso{\code{\link{bipropApp}}, \code{\link{districtwiseApp}}, and \code{\link{monopropApp}}}

\examples{
# compute bipropotional apportionment using data of Zurich City Parliament election
data(GRW2006)
computeApportionment(GRW2006)
}

\references{
	\url{http://www.uni-augsburg.de/bazi}.
	
	Maier, S. and Pukelsheim, F. (2007) \emph{BAZI - A Free Program for Proportional
	Representation Apportionment}, Preprint No. 42, Institute for Mathematics,
	University of Augsburg.
	
}	

\keyword{math}
