\name{idealshare}

\alias{idealshare}

\title{Computing ideal shares}

\description{Computes ideal shares}

\usage{
idealshare(votes, housesize=NULL, districtMagnitudes=NULL, partySeats=NULL, acc=1e-10)
}


\arguments{
	\item{votes}{Matrix/vector with input weights, e.g. votes for parties}
	\item{housesize}{Number of seats in the parliament}
	\item{districtMagnitudes}{District (row) marginals}
	\item{partySeats}{Party (column) marginals}
	\item{acc}{Accuracy for IPFP}

}

\details{
Returns different kinds of ideal shares depending on the provided input.
}

\value{

}

\seealso{\code{\link{computeApportionment}}}

\references{
	\url{http://www.uni-augsburg.de/bazi}.
	
	Maier, S. and Pukelsheim, F. (2007) \emph{BAZI - A Free Program for Proportional
	Representation Apportionment}, Preprint No. 42, Institute for Mathematics, University of 
	Augsburg.
	
	Maier, S. Zachariassen, P. and Zachariasen, M. (2007) \emph{Divisor-Based
	Biproportional Apportionment in Electoral Systems: A Real-Life Benchmark Study},
	Preprint No. 39, Institute for Mathematics, University of Augsburg.
}	

\keyword{math}
